/* 
 * Jukebox main shell
 * ------------------
 * copyright (c) 1997-1999 by Roger Walker, All rights reserved.
 * See the file RNW_COPY
 *
 * Uses the routines in jukereal.c or juke_new.c to add and remove tracks
 * to or from the play list
 *
 *  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
 *  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
 *  PURPOSE.
 */
#include <conio.h>
#include <dos.h>
#include <string.h>
#include <ctype.h>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "jukebox.h"

extern trk_info_t *trks;
extern int nsorted;

// From findfile.c
extern play_list_t toplay[MAX_PLAY];
extern int ntoplay,max_toplay,total_played;
extern bool really_exit,background_mode;

int main(int argc, char *argv[])
{ int err;

  track_init();
  printf("%d tracks found\n",nsorted);
  if (nsorted==0)
  { track_exit();
    return 99;
  }

  ntoplay=total_played=0;
  max_toplay=MAX_PLAY;
  background_mode=false;

  display_init();
  status_reset();

  write_to_log("Restarted jukebox program");
  if ((err=player_init())==0)
   { FILE *in;
     time_t started;
     int nrand;

     time(&started); 

     // Make the pseudo random numbers a bit more random
     srand(started);
     for (nrand=0 ; nrand<200 ; nrand++) rand();

     // Remember how many we've played in sequence
     nrand=0;

     really_exit=false;
     while (!really_exit)
      { run_idle_task();
        // Background mode overrides any selected tracks
        if (background_mode==true)
         { int old;
           write_to_log("Inserting random background track");
           // Insert at the begining of the list
           track_add_at(track_find(0),0);
         }

        // If nothing to play, work out what to do
        if (ntoplay==0)
         { if (total_played==0)
           { // Nothing ever played so give them 30 seconds
             time_t tmp;
             time(&tmp);
             if ((tmp-started)<30) continue;
           } else
           if (access("end.mp3",04)==0)
           { // We have the end track so play it one in 4 times
             if (((nrand++)&3)==0)
             { status_refresh();
			   write_to_log("Playing end.mp3");
               player_play_file("end.mp3");
               if (really_exit) continue;
             }            
           }
         } else
         { // Reset number of random tracks so that 1st random track plays end.mp3
           nrand=0;
         }

         // Insert the random track
         if (ntoplay==0)
         { write_to_log("Adding random track");
           track_add(track_find(-1));
         }
   
        { char buf[256];
          sprintf(buf,"About to play %s %s",track_label(toplay[0].trk_index),trks[toplay[0].trk_index].fname);
          write_to_log(buf);
        }

        // Remember the last time this track was played
        time((time_t *)&trks[toplay[0].trk_index].last_played);
        track_sort();
        status_update_tracklist();

        // Play the track
        err=player_play_file(trks[toplay[0].trk_index].fname);
        track_sort();
        // Finished playing one
        ntoplay--;

        // If any more to play, move them down in the list
        if (ntoplay) memmove(toplay,toplay+1,ntoplay*sizeof(play_list_t));

        // Remember how many we've played
        total_played++;
      }
     track_exit();
     player_exit();
   }
  ntoplay=(-1); 
  status_update_tracklist();
  write_to_log("Exiting\n");
  display_exit();
  return err;
}
