/* 
 * Audio player test harness
 *
 */
#include <conio.h>
#include <dos.h>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "jukebox.h"

WORD secs_remaining;

extern FILE *rawFile;

int main(int argc, char *argv[])
{ int f,err;
  char fileOut;

  if ((err=player_init())!=0) return err;

  fileOut=0;
  rawFile=NULL;
  for (f=1,err=0 ; f<argc && err==0 ; f++)
  { if (stricmp(argv[f],"/f")==0 ||
		stricmp(argv[f],"-f")==0)
	{	fileOut=1;
		continue;
	}
	if (fileOut)
	{	char fname[256],*cp;
		cp=strrchr(argv[f],'/');
		if (cp)
		{ cp++;
		} else
		{ cp=strrchr(argv[f],':');
		  if (cp)
		  { cp++;
		  } else
		  { cp=argv[f];
		  }
		}
		strcpy(fname,cp);
		cp=strrchr(fname,'.');
		if (!cp)
		{ fprintf(stderr,"Skipping %s\n",argv[f]);
		  continue;
		}
		strcpy(cp,".raw");
		fprintf(stderr,"Creating '%s' ",fname);fflush(stderr);
		rawFile=fopen(fname,"wb");
		fprintf(stderr," as %p\n",rawFile);fflush(stderr);
	}
	err=player_play_file(argv[f]);
	if (rawFile)
	{	fclose(rawFile);
		rawFile=NULL;
	}
  }

  player_exit();
  return err;
}

void run_idle_task(void)
{ 
}

void display_playing_status(int nSecs,int nBusy)
{ fprintf(stderr,"%3d:%02d %3d" "\b\b\b\b\b\b\b\b\b\b",nSecs/60,nSecs%60,nBusy);
}

#ifndef __DJGPP__
extern BYTE gBufNowPlaying;
#endif

void status_update(void)
{ static WORD last;
  if (kbhit())
   { int key;
     key=getch(); if (key==0) key=256+getch();
     if (key==KEY_ESC) player_abort_playing();
   }
#ifndef __DJGPP__
  if (last!=gBufNowPlaying)
   { printf("%d",gBufNowPlaying);
     last=gBufNowPlaying;
   } else
#endif
   { fputs("",stdout);
   }
}

