/* 
 * Audio sub system tester
 *
 */

#include <stdlib.h>
#include <sys/time.h>
#include <sys/resource.h>

/* #define SET_PRIO */

#include "mpg123.h"
#include "mlib.h"

// 2*44100 samples = 1 second of stereo
#define SIZE 2*44100
WORD audioBuf1[SIZE];
WORD audioBuf2[SIZE];

void playSamples(WORD *buf,int len)
{ int totalBytes,nBytes;
  len*=2; // Convert number of 16-bit samples to number of bytes

  totalBytes=0;
  while (len>0)
  { nBytes=audioPlay(((char *)buf)+totalBytes,len);
//printf("%5lX %5lX %5lX\n",totalBytes, len, nBytes);
    totalBytes+=nBytes;
    len-=nBytes;
    if (len==0)
    { // nBusy++;
      break;
    } else
    { // Didn't get them all in !
      run_idle_task();
    }
  }
//  return totalBytes;
}


main(int argc,char *argv[])
{ int i,size1,size2,test;
  size1=size2=0;
  for (i=0 ; i<SIZE; i++)
  {	audioBuf1[i]=((i/2)&0xFF)<<8;
	if (audioBuf1[i]==0) size1=i;
	audioBuf2[i]=((i/4)&0xFF)<<8;
	if (audioBuf2[i]==0) size2=i;
  }

  printf("Init\n");
  audioInit(44100,16,2);
  switch((argc!=2) ? 0 : atoi(argv[1]))
  { case 1:
	printf("Short play 1 %d\n",size1/10);
	playSamples(audioBuf1,size1/10);
	break;

    case 2:
	for (i=0 ; i<SIZE ; i++)
	{ audioBuf1[i]=(i&1) ? 1 : -1;
	}
	printf("Signed test 1 & -1, %d samples\n",size1);
	playSamples(audioBuf1,size1);
	break;

    case 3:
	for (i=0 ; i<SIZE ; i++)
	{ audioBuf1[i]=(i&1) ? 0x8001 : 0x7FFF;
	}
	printf("Signed test 0x8001 & 0x7FFF, %d samples\n",size1);
	playSamples(audioBuf1,size1);
	break;

    case 0:
    default:
	printf("Play 1 %d\n",size1);
	playSamples(audioBuf1,size1); playSamples(audioBuf1,size1);
	printf("Play 2 %d\n",size2);
	playSamples(audioBuf2,size2); playSamples(audioBuf2,size2);
	printf("Play 1 %d\n",size1);
	playSamples(audioBuf1,size1); playSamples(audioBuf1,size1);
	break;
  }

  printf("Complete\n");
  audioComplete();
  printf("Exit\n");
  audioExit();
  printf("Bye\n");
}
